﻿Imports System.Data.OleDb

Module DBConn

    Public Class MyDataLink
        Public conn As OleDbConnection
        'Public adapter As OleDbDataAdapter

        Public Shared Function Open(dbPath As String) As MyDataLink
            Try
                Dim res As New MyDataLink(dbPath)
                '
                Return res
            Catch ex As Exception
                Return Nothing
            End Try
        End Function

        Public Sub New(dbPath)
            conn = New OleDbConnection("Provider=microsoft.Jet.oledb.4.0; Data Source=" & dbPath & ";")

        End Sub

        Public Function LoadEllipsoidDesc(pid As Integer) As MyEllipsoidDesc
            If pid = 0 Then
                Return Nothing
            Else
                Dim wCom As OleDbCommand = conn.CreateCommand
                wCom.CommandText = "SELECT e.Number, e.Ellipsoid, e.a, e.f1, e.epsg FROM Ellipsoid AS e WHERE (e.Number=@pid);"
                wCom.Parameters.AddWithValue("@pid", pid)
                '
                If conn.State = ConnectionState.Closed Then
                    conn.Open()
                End If
                '
                Dim reader As OleDbDataReader
                reader = wCom.ExecuteReader
                reader.Read()
                Dim res As New MyEllipsoidDesc
                res.id = pid
                res.Name = reader.Item("Ellipsoid").ToString
                res.a = reader.Item("a")
                res.f1 = reader.Item("f1")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                'res.WKT_Name = reader.Item("WKT").ToString
                reader.Close()
                '
                conn.Close()
                Return res
            End If
        End Function

        Public Function LoadDatum3(pid As Integer, Elist As List(Of MyEllipsoidDesc)) As Datum3
            If pid = 0 Then
                Return Nothing
            Else
                Dim wCom As OleDbCommand = conn.CreateCommand
                wCom.CommandText = "SELECT d3.Datum_, d3.Datum_Name, d3.Ellipsoid, d3.ShiftX, d3.ShiftY, d3.ShiftZ, d3.epsg FROM Datum3Parameters AS d3 WHERE (d3.Datum_=@pid);"
                wCom.Parameters.AddWithValue("@pid", pid)
                '
                If conn.State = ConnectionState.Closed Then
                    conn.Open()
                End If
                '
                Dim reader As OleDbDataReader
                reader = wCom.ExecuteReader
                reader.Read()
                Dim res As New Datum3
                res.id = pid
                res.Name = reader.Item("Datum_Name").ToString
                Dim ei As Integer = reader.Item("Ellipsoid")
                res.Ellipsoid = Elist.Find(Function(e) e.id = ei)
                res.X = reader.Item("ShiftX")
                res.Y = reader.Item("ShiftY")
                res.Z = reader.Item("ShiftZ")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                'res.WKT_Name = reader.Item("WKT").ToString
                reader.Close()
                '
                conn.Close()
                Return res
            End If
        End Function

        Public Function LoadDatum8(pid As Integer, Elist As List(Of MyEllipsoidDesc)) As Datum8
            If pid = 0 Then
                Return Nothing
            Else
                Dim wCom As OleDbCommand = conn.CreateCommand
                wCom.CommandText = "SELECT d8.Datum_, d8.Datum_Name, d8.Ellipsoid, d8.ShiftX, d8.ShiftY, d8.ShiftZ, d8.RotationX, d8.RotationY, d8.RotationZ, d8.scale_ppm, d8.Prime_Meridian, d8.epsg FROM Datum8parameters AS d8 WHERE (d8.Datum_=@pid);"
                wCom.Parameters.AddWithValue("@pid", pid)
                '
                If conn.State = ConnectionState.Closed Then
                    conn.Open()
                End If
                '
                Dim reader As OleDbDataReader
                reader = wCom.ExecuteReader
                reader.Read()
                Dim res As New Datum8
                res.id = pid
                res.Name = reader.Item("Datum_Name").ToString
                Dim ei As Integer = reader.Item("Ellipsoid")
                res.Ellipsoid = Elist.Find(Function(e) e.id = ei)
                res.X = reader.Item("ShiftX")
                res.Y = reader.Item("ShiftY")
                res.Z = reader.Item("ShiftZ")
                res.RotationX = reader.Item("RotationX")
                res.RotationY = reader.Item("RotationY")
                res.RotationZ = reader.Item("RotationZ")
                res.Scale_ppm = reader.Item("scale_ppm")
                res.Prime_Meridian = reader.Item("Prime_Meridian")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                'res.WKT_Name = reader.Item("WKT").ToString
                reader.Close()
                '
                conn.Close()
                Return res
            End If
        End Function

        'MyProjectionDesc
        Public Function LoadProjectionDesc(pid As Integer) As MyProjectionDesc
            If pid = 0 Then
                Return Nothing
            Else
                Dim wCom As OleDbCommand = conn.CreateCommand
                wCom.CommandText = "SELECT prj.Number, prj.Name, prj.ru_name, prj.WKT, prj.EPSG, prj.proj FROM ProjList AS prj WHERE (prj.Number=@pid);"
                wCom.Parameters.AddWithValue("@pid", pid)
                '
                If conn.State = ConnectionState.Closed Then
                    conn.Open()
                End If
                '
                Dim reader As OleDbDataReader
                reader = wCom.ExecuteReader
                reader.Read()
                Dim res As New MyProjectionDesc
                res.id = pid
                res.Name = reader.Item("Name").ToString
                res.ruName = reader.Item("ru_name").ToString
                res.WKT_Name = reader.Item("WKT").ToString
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                res.proj_Name = reader.Item("proj").ToString
                reader.Close()
                '
                res.ParamList = LoadParamList(pid)
                conn.Close()
                Return res
            End If
        End Function

        Public Function LoadParamDesc(pid As Integer) As MyParamDesc
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT pp.id, pp.pname, pp.desc, pp.epsg, pp.proj, pp.wkt_name FROM ProjParam AS pp WHERE (pp.id=@pid);"
            wCom.Parameters.AddWithValue("@pid", pid)
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            reader.Read()
            Dim res As New MyParamDesc
            res.id = pid
            res.Name = reader.Item("pname").ToString
            res.Desc = reader.Item("desc").ToString
            res.WKT_Name = reader.Item("wkt_name").ToString
            Dim wObj As Object = reader.Item("EPSG")
            If Not IsDBNull(wObj) Then res.EPSG = wObj
            res.proj_Name = reader.Item("proj").ToString
            reader.Close()
            'conn.Close()
            Return res
        End Function

        Public Function LoadParamList(pid As Integer) As List(Of MyParamDesc)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT ppl.par_id FROM ProjParamLinks AS ppl where prj_id=@pid;"
            wCom.Parameters.AddWithValue("@pid", pid)
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            '
            Dim idList As New List(Of Integer)
            While reader.Read()
                idList.Add(reader.GetInt32(0))
            End While
            reader.Close()
            'Dim res As MyParamDesc
            Dim resList As New List(Of MyParamDesc)
            For Each i In idList
                resList.Add(Me.LoadParamDesc(i))
            Next
            Return resList
        End Function

        '!
        Public Function LoadUnitList() As List(Of MyUnits)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT u.Number, u.Units, u.Ru_name, u.proj, u.epsg, u.target_epsg, u.b, u.c FROM Units AS u;"
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            Dim reader As OleDbDataReader
            Dim res As MyUnits
            Dim resList As New List(Of MyUnits)
            Dim wObj As Object
            reader = wCom.ExecuteReader
            While reader.Read()
                res = New MyUnits
                res.id = reader.Item("Number")
                res.Name = reader.Item("Units").ToString
                res.ruName = reader.Item("Ru_name").ToString
                res.proj = reader.Item("proj").ToString
                wObj = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                wObj = reader.Item("target_epsg")
                If Not IsDBNull(wObj) Then res.target_EPSG = wObj
                res.b = reader.Item("b")
                res.c = reader.Item("c")
                resList.Add(res)
            End While
            reader.Close()
            'conn.Close()
            Return resList
        End Function

        Public Function LoadEllipsoidList() As List(Of MyEllipsoidDesc)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT e.Number, e.Ellipsoid, e.a, e.f1, e.epsg,e.proj FROM Ellipsoid AS e;"
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            '
            Dim reader As OleDbDataReader
            Dim res As MyEllipsoidDesc
            Dim resList As New List(Of MyEllipsoidDesc)
            reader = wCom.ExecuteReader
            While reader.Read()
                res = New MyEllipsoidDesc
                res.id = reader.Item("Number")
                res.Name = reader.Item("Ellipsoid").ToString
                res.a = reader.Item("a")
                res.f1 = reader.Item("f1")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                wObj = reader.Item("proj")
                If Not IsDBNull(wObj) Then res.proj = wObj
                resList.Add(res)
            End While
            reader.Close()
            'conn.Close()
            Return resList
        End Function

        Public Function LoadDatum3List(Elist As List(Of MyEllipsoidDesc)) As List(Of Datum3)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT d3.Datum_, d3.Datum_Name, d3.Ellipsoid, d3.ShiftX, d3.ShiftY, d3.ShiftZ, d3.epsg, d3.proj FROM Datum3Parameters AS d3;"
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            '
            Dim reader As OleDbDataReader
            Dim res As Datum3
            Dim resList As New List(Of Datum3)
            reader = wCom.ExecuteReader
            While reader.Read()
                res = New Datum3
                res.id = reader.Item("Datum_")
                res.Name = reader.Item("Datum_Name").ToString
                Dim ei As Integer = reader.Item("Ellipsoid")
                res.Ellipsoid = Elist.Find(Function(e) e.id = ei)
                res.X = reader.Item("ShiftX")
                res.Y = reader.Item("ShiftY")
                res.Z = reader.Item("ShiftZ")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                wObj = reader.Item("proj")
                If Not IsDBNull(wObj) Then res.proj = wObj
                resList.Add(res)
            End While
            'res.WKT_Name = reader.Item("WKT").ToString
            reader.Close()
            'conn.Close()
            Return resList
        End Function

        Public Function LoadDatum8List(Elist As List(Of MyEllipsoidDesc)) As List(Of Datum8)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT d8.Datum_, d8.Datum_Name, d8.Ellipsoid, d8.ShiftX, d8.ShiftY, d8.ShiftZ, d8.RotationX, d8.RotationY, d8.RotationZ, d8.scale_ppm, d8.Prime_Meridian, d8.epsg, d8.proj FROM Datum8parameters AS d8;"
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            '
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            reader.Read()
            Dim ei As Integer
            Dim res As Datum8
            Dim resList As New List(Of Datum8)
            While reader.Read()
                res = New Datum8
                res.id = reader.Item("Datum_")
                res.Name = reader.Item("Datum_Name").ToString
                ei = reader.Item("Ellipsoid")
                res.Ellipsoid = Elist.Find(Function(e) e.id = ei)
                res.X = reader.Item("ShiftX")
                res.Y = reader.Item("ShiftY")
                res.Z = reader.Item("ShiftZ")
                res.RotationX = reader.Item("RotationX")
                res.RotationY = reader.Item("RotationY")
                res.RotationZ = reader.Item("RotationZ")
                res.Scale_ppm = reader.Item("scale_ppm")
                res.Prime_Meridian = reader.Item("Prime_Meridian")
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                wObj = reader.Item("proj")
                If Not IsDBNull(wObj) Then res.proj = wObj
                'res.WKT_Name = reader.Item("WKT").ToString
                resList.Add(res)
            End While
            reader.Close()
            'conn.Close()
            Return resList
        End Function

        Public Function LoadParamList() As List(Of MyParamDesc)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT pp.id, pp.pname, pp.desc, pp.epsg, pp.proj, pp.wkt_name FROM ProjParam AS pp;"
            '
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            Dim res As New MyParamDesc
            Dim resList As New List(Of MyParamDesc)
            While reader.Read()
                res = New MyParamDesc
                res.id = reader.Item("id")
                res.Name = reader.Item("pname").ToString
                res.Desc = reader.Item("desc").ToString
                res.WKT_Name = reader.Item("wkt_name").ToString
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                res.proj_Name = reader.Item("proj").ToString
                resList.Add(res)
            End While
            reader.Close()
            'conn.Close()
            Return resList
        End Function

        Public Function LoadProjectionList() As List(Of MyProjectionDesc)
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT prj.Number, prj.Name, prj.ru_name, prj.WKT, prj.EPSG, prj.proj FROM ProjList AS prj;"
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            '
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            Dim res As New MyProjectionDesc
            Dim resList As New List(Of MyProjectionDesc)
            While reader.Read()
                res = New MyProjectionDesc
                res.id = reader.Item("Number")
                res.Name = reader.Item("Name").ToString
                res.ruName = reader.Item("ru_name").ToString
                res.WKT_Name = reader.Item("WKT").ToString
                Dim wObj As Object = reader.Item("EPSG")
                If Not IsDBNull(wObj) Then res.EPSG = wObj
                res.proj_Name = reader.Item("proj").ToString
                resList.Add(res)
            End While
            reader.Close()
            'res.ParamList = LoadParamList(pid)
            'conn.Close()
            Return resList
        End Function

        Public Sub LoadProjParamLinks(paList As List(Of MyParamDesc), prjList As List(Of MyProjectionDesc))
            Dim wCom As OleDbCommand = conn.CreateCommand
            wCom.CommandText = "SELECT ppl.prj_id, ppl.par_id FROM ProjParamLinks AS ppl ORDER BY ppl.prj_id;"
            If conn.State = ConnectionState.Closed Then
                conn.Open()
            End If
            Dim reader As OleDbDataReader
            reader = wCom.ExecuteReader
            Dim id1, id2 As Integer
            Dim wPa As MyParamDesc
            Dim wPrj As MyProjectionDesc = prjList(0)
            While reader.Read()
                id1 = reader.Item("prj_id")
                id2 = reader.Item("par_id")
                If wPrj.id <> id1 Then
                    wPrj = prjList.Find(Function(Prj) Prj.id = id1)
                End If
                wPa = paList.Find(Function(pa) pa.id = id2)
                wPrj.ParamList.Add(wPa)
            End While
            reader.Close()
        End Sub

    End Class

End Module
